/*
==============================================================================

COPYRIGHT (C) 2001 Sergei Hristov Kostov       Bulgaria city:Razgrad 

date:25.07.2001

 This file is part of S(imple)view free software; you can redistribute it
 and/or modify it under the terms of the GNU General Public License as
 published by the Free Software Foundation; either version 2 of the
 License, or any later version.
  
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
      
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 See COPYING for more details.
 
==============================================================================
*/

#include <SDL/SDL.h>
#include <SDL/SDL_image.h>
#include <sys/types.h>
#include <dirent.h>
#include <stream.h>
#include <stdlib.h>


struct image_list
     {
           struct image_list *prev;
	   char *name;
	   struct image_list *next;
     };
     

struct image_list *image_names,start;
struct dirent **namelist;
int nfiles,stat=1,OK=-1;


	void Error(char *kind,int fatal)
	{
	cerr<<"Aview Report: "<<kind<<"\n";
	if (fatal==1)
	 {
	   cerr<<"Exiting...\n";
	   exit(1);
	 };
        };
      
      
      void Imagelist_first()
      { 
      image_names=&start;
      image_names->prev=NULL;
      image_names->next=NULL;
      };
	   
       
      int Imagelist_Add_New(void)
	   {
	   struct image_list* save_prev;
	   save_prev=image_names;//zapazvane adresa na stariq element
	   image_names->next = (struct image_list*)malloc(sizeof(struct image_list));
           if(image_names->next==NULL)
	      Error("Not enough memory",1);
	   image_names=image_names->next; //prehvurlqne kum adresa na noiq element
	   image_names->prev=save_prev;//adresa na stariq element -> prev;
	   image_names->next=NULL; //za da se znae koe e krai
           };
	  
	   
       int Imagelist_GoTo_prev(void)
       {
	if (image_names->prev==&start)//tova e purviqt element
          return -1;
	image_names=image_names->prev;//prehvurlqne edin element nazad
       };
	
	
       int Imagelist_GoTo_next(void)
	{
	 if (image_names->next==NULL)// tova e posledniqt element
	  return -1;
	 image_names=image_names->next;//edin element napred
	};
	  
	  
	void Imagelist_To_first(void)
	  {
	  //while(Imagelist_GoTo_prev()>0){};
	  image_names=&start;
	  image_names=image_names->next;
	  };
	
	  
	int get_namelist(const char *dir)
	{
	  nfiles = scandir(dir, &namelist, 0, alphasort);
	    if (nfiles<0)
	           {
		            Error("Can't scan directory",0);
			    return -1;
	           };
	    return 0;   
	};
	
	
	void Add_To_List(int j)
	 {
	  OK=0;
	  Imagelist_Add_New();
	  image_names->name=namelist[j]->d_name;
	 };
	 
	
	void Free_Imagelist()
	 {
	  while(Imagelist_GoTo_next()>0){};
	  while(Imagelist_GoTo_prev()>0)
	     {
	      delete image_names->next;
	     };
	 };
	
	int Find_Out_Supported_Images(void)
	 {
	  int i,status;
	  SDL_RWops *src;
	  for (i=0;i<nfiles;i++)
	   {
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isXPM(src)==1) Add_To_List(i);
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isGIF(src)==1) Add_To_List(i);
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isJPG(src)==1) Add_To_List(i);
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isPCX(src)==1) Add_To_List(i);
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isPNG(src)==1) Add_To_List(i);
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isPNM(src)==1) Add_To_List(i); 
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isTIF(src)==1) Add_To_List(i); 
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isXCF(src)==1) Add_To_List(i); 
	      src = SDL_RWFromFile(namelist[i]->d_name,"rb");
	      if (IMG_isBMP(src)==1) Add_To_List(i);
	      SDL_RWclose(src);
	   };
	  return (OK);
        };
		   
	int Is_Supported(const char *name)
	  {
	   int stat=-1;
	   SDL_RWops *src;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isXPM(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isGIF(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isJPG(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isPCX(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isPNG(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isPNM(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isTIF(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isXCF(src)==1) stat=1;
		   src = SDL_RWFromFile(name,"rb");
		   if (IMG_isBMP(src)==1) stat=1;
		   SDL_RWclose(src);
	   return (stat);
	  };